<?php

/* Teowin Grid Settings Page */
class twjtable_Admin_Settings {
	public function __construct() {
		add_action( 'admin_menu', array( $this, 'wph_create_settings' ) );
		add_action( 'admin_init', array( $this, 'wph_setup_sections' ) );
		add_action( 'admin_init', array( $this, 'wph_setup_fields' ) );

		add_action( 'updated_option', array($this, 'updated_option_callback'), 10, 3 );
	}

	public function wph_create_settings() {
		$page_title = 'Teowin Grid for Formidable Pro settings';
		$menu_title = 'Teowin Grid';
		$capability = 'manage_options';
		$slug = 'teowingrid';
		$callback = array($this, 'wph_settings_content');
		add_options_page($page_title, $menu_title, $capability, $slug, $callback);
	}

	public function wph_settings_content() { ?>
        <div class="wrap">
            <h1>Teowin Grid for Formidable Pro settings</h1>
			<?php settings_errors();
            if ( isset( $_GET['settings-updated'] ) ) {

            // add error/update messages

            // check if the user have submitted the settings
            // wordpress will add the "settings-updated" $_GET parameter to the url
            // add settings saved message with the class of "updated"
            add_settings_error( 'wporg_messages', 'wporg_message', __( 'Settings Saved', 'wporg' ), 'updated' );
            };
            ?>

            <form method="POST" action="options.php">
				<?php
				settings_fields( 'teowingrid' );
				do_settings_sections( 'teowingrid' );
				submit_button();
				?>
            </form>
        </div> <?php
	}

	public function wph_setup_sections() {
		add_settings_section( 'teowingrid_section', 'Modify the settings for Teowin Grid for Formidable Pro', array(), 'teowingrid' );
	}

	public function wph_setup_fields() {
		$fields = array(
			array(
				'label' => 'License code',
				'id' => 'twgrid_lic_code',
				'type' => 'text',
				'section' => 'teowingrid_section',
				'desc' => 'Your license for Teowin Grid plugin. This code can be found in the registration email.',
			),
			array(
				'label' => 'Email adress',
				'id' => 'twgrid_lic_email',
				'type' => 'email',
				'section' => 'teowingrid_section',
				'desc' => 'The email adress used for registering.',
			),
		);
		foreach( $fields as $field ){
			add_settings_field( $field['id'], $field['label'], array( $this, 'wph_field_callback' ), 'teowingrid', $field['section'], $field );
			register_setting( 'teowingrid', $field['id'] );
		}
	}

	public function wph_field_callback( $field ) {
		$value = get_option( $field['id'] );
		switch ( $field['type'] ) {
			default:
				printf( '<input name="%1$s" id="%1$s" type="%2$s" placeholder="%3$s" value="%4$s" />',
					$field['id'],
					$field['type'],
					$field['placeholder'],
					$value
				);
		}
		if( $desc = $field['desc'] ) {
			printf( '<p class="description">%s </p>', $desc );
		}
	}

	public function updated_option_callback( $option, $old_value, $value ) {
		//the url where the WooCommerce Software License plugin is being installed
	//	define('SL_APP_API_URL',      'teowintest.test:81/index.php');

        //the Software Unique ID as defined within product admin page
	//	define('SL_PRODUCT_ID',           'twGridMollie');

 /*       $license_key = get_option('twgrid_lic_code');
		$args = array(
			'woo_sl_action'     => 'activate',
			'licence_key'       => $license_key,
			'product_unique_id' => TWGRID_WOO_PRODUCT_ID,
			'domain'            => TWGRID_WOO_INSTANCE
		);
		$request_uri    = TWGRID_WOO_APP_API_URL . '?' . http_build_query( $args );
		$data           = wp_remote_get( $request_uri );

		if(is_wp_error( $data ) || $data['response']['code'] != 200)
		{
			//there was a problem establishing a connection to the API server
		}

		$data_body = json_decode($data['body']);
		if(isset($data_body->status))
		{
			if($data_body->status == 'success' && $data_body->status_code == 's200')
			{
				//the license is active and the software is active
				//doing further actions like saving the license and allow the plugin to run

			}
			else
			{
				//there was a problem activating the license
			}
		}
		else
		{
			//there was a problem establishing a connection to the API server
		}
		*/
	}


}




